"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LOAD_USERS = exports.LOAD_SEARCH_LIST = exports.LOAD_PARTICIPANTS = exports.LOAD_NEWMESSAGES = exports.LOAD_MESSAGES = void 0;

var _client = require("@apollo/client");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5;

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

const LOAD_USERS = (0, _client.gql)(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  subscription {\n    queryHC_Lead {\n      id\n      username\n      threads {\n        id\n        messages(order: { desc: timestamp }, offset: 0, first: 1) {\n          id\n          from\n          to\n          timestamp\n          body\n          username\n        }\n      }\n    }\n  }\n"])));
exports.LOAD_USERS = LOAD_USERS;
const LOAD_MESSAGES = (0, _client.gql)(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  query($leadId: ID!) {\n    getHC_Lead(id: $leadId) {\n      username\n      threads {\n        id\n        messages {\n          from\n          to\n          timestamp\n          body\n          type\n          id\n          username\n        }\n        participants {\n          ... on HC_Lead {\n            username\n          }\n          ... on HC_Staff {\n            username\n          }\n        }\n      }\n    }\n  }\n"])));
exports.LOAD_MESSAGES = LOAD_MESSAGES;
const LOAD_NEWMESSAGES = (0, _client.gql)(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  subscription {\n    queryMessage(order: { desc: timestamp }, offset: 0, first: 1) {\n      id\n      type\n      thread {\n        id\n      }\n      body\n      timestamp\n      from\n      to\n    }\n  }\n"])));
exports.LOAD_NEWMESSAGES = LOAD_NEWMESSAGES;
const LOAD_SEARCH_LIST = (0, _client.gql)(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  query message($filter: MessageFilter) {\n    queryMessage(filter: $filter) {\n      id\n      body\n      from\n      timestamp\n      username\n      thread {\n        id\n        sender {\n          id\n          username\n        }\n      }\n    }\n  }\n"])));
exports.LOAD_SEARCH_LIST = LOAD_SEARCH_LIST;
const LOAD_PARTICIPANTS = (0, _client.gql)(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  query($leadId: ID!) {\n    getHC_Lead(id: $leadId) {\n      username\n      threads {\n        id\n        participants {\n          ... on HC_Lead {\n            username\n          }\n          ... on HC_Staff {\n            username\n          }\n        }\n      }\n    }\n  }\n"])));
exports.LOAD_PARTICIPANTS = LOAD_PARTICIPANTS;