"use strict";

require("core-js/modules/es.promise.js");

var _testing = require("@apollo/client/testing");

var _react = require("@testing-library/react");

var _react2 = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _ChatContext = _interopRequireDefault(require("../../context/chat/ChatContext"));

var _ChatItem = _interopRequireDefault(require("./ChatItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const mocks = [];
const value = {
  unrepliedCount: {
    "0x2724": 13
  }
};

const comp = /*#__PURE__*/_react2.default.createElement(_ChatContext.default.Provider, {
  value: value
}, /*#__PURE__*/_react2.default.createElement(_testing.MockedProvider, {
  mocks: mocks
}, /*#__PURE__*/_react2.default.createElement(_ChatItem.default, null)), "    ");

describe('rendring of components', () => {
  it('It should mount', () => {
    const div = document.createElement('div');

    _reactDom.default.render(comp, div);

    _reactDom.default.unmountComponentAtNode(div);
  });
});
describe('mounting with data', () => {
  let prop = {
    username: "Sahil Thakur",
    id: "0x2725",
    threads: [{
      id: "0x2724",
      messages: [{
        from: "whatsapp:+918988413260",
        to: "whatsapp:+14155238886",
        timestamp: "1637295513344",
        body: "Sending first message",
        __typename: "Message"
      }, {
        from: "whatsapp:+918988413260",
        to: "whatsapp:+14155238886",
        timestamp: "1637295528041",
        body: "Second message from me",
        __typename: "Message"
      }],
      __typename: "Thread"
    }],
    __typename: "HC_Lead"
  };
  it('Item mount with data', async () => {
    let el = /*#__PURE__*/_react2.default.createElement(_ChatContext.default.Provider, {
      value: value
    }, /*#__PURE__*/_react2.default.createElement(_testing.MockedProvider, {
      mocks: []
    }, /*#__PURE__*/_react2.default.createElement(_ChatItem.default, {
      user: prop
    })), "    ");

    await new Promise(resolve => setTimeout(resolve, 4000)); // wait for response

    const {
      container,
      getByText
    } = (0, _react.render)(el);
    expect(getByText("Sahil Thakur")).toBeInTheDocument();
  });
  it('Item mount with unreplied count', async () => {
    let el = /*#__PURE__*/_react2.default.createElement(_ChatContext.default.Provider, {
      value: value
    }, /*#__PURE__*/_react2.default.createElement(_testing.MockedProvider, {
      mocks: []
    }, /*#__PURE__*/_react2.default.createElement(_ChatItem.default, {
      user: prop
    })), "    ");

    await new Promise(resolve => setTimeout(resolve, 4000)); // wait for response

    const {
      container,
      getByText
    } = (0, _react.render)(el);
    expect(getByText("13")).toBeInTheDocument();
  });
});