"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.sort.js");

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _ChatItem = _interopRequireDefault(require("../ChatItem/ChatItem"));

var _ChatListModule = _interopRequireDefault(require("./ChatList.module.scss"));

var _icons = require("@ant-design/icons");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ChatList = _ref => {
  var _users$filter, _users$filter$sort;

  let {
    data
  } = _ref;
  const navigate = (0, _reactRouterDom.useNavigate)();
  const [users, setUsers] = (0, _react.useState)([]);
  const [chosen, setChosen] = (0, _react.useState)(null);
  (0, _react.useEffect)(() => {
    if (data) {
      setUsers(data.queryHC_Lead);
    }
  }, [data]);

  const handleSetChosen = value => {
    if (value === chosen) return;
    setChosen(value);
    navigate("/chat/".concat(value));
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: _ChatListModule.default.ChatList
  }, (_users$filter = users.filter(e => {
    var _e$threads$, _e$threads$$messages;

    return (e === null || e === void 0 ? void 0 : (_e$threads$ = e.threads[0]) === null || _e$threads$ === void 0 ? void 0 : (_e$threads$$messages = _e$threads$.messages) === null || _e$threads$$messages === void 0 ? void 0 : _e$threads$$messages.length) > 0;
  })) === null || _users$filter === void 0 ? void 0 : (_users$filter$sort = _users$filter.sort((a, b) => {
    var _b$threads$, _b$threads$$messages$, _a$threads$, _a$threads$$messages$;

    return ((_b$threads$ = b.threads[0]) === null || _b$threads$ === void 0 ? void 0 : (_b$threads$$messages$ = _b$threads$.messages[0]) === null || _b$threads$$messages$ === void 0 ? void 0 : _b$threads$$messages$.timestamp) - ((_a$threads$ = a.threads[0]) === null || _a$threads$ === void 0 ? void 0 : (_a$threads$$messages$ = _a$threads$.messages[0]) === null || _a$threads$$messages$ === void 0 ? void 0 : _a$threads$$messages$.timestamp);
  })) === null || _users$filter$sort === void 0 ? void 0 : _users$filter$sort.map(user => {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: user.id
    }, /*#__PURE__*/_react.default.createElement(_ChatItem.default, {
      "data-testid": "ChatItem",
      key: user.id,
      user: user,
      active: user.id === chosen,
      onClick: () => handleSetChosen(user.id)
    }));
  }), /*#__PURE__*/_react.default.createElement("button", {
    className: _ChatListModule.default.ChatList__newChat
  }, /*#__PURE__*/_react.default.createElement(_icons.MessageFilled, null)));
};

var _default = ChatList;
exports.default = _default;