"use strict";

require("core-js/modules/es.promise.js");

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _ChatList = _interopRequireDefault(require("./ChatList"));

var _testing = require("@apollo/client/testing");

var _Queries = require("../../GraphQL/Queries");

var _react2 = require("@testing-library/react");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const mockedUsedNavigate = jest.fn();
jest.mock('react-router-dom', () => _objectSpread(_objectSpread({}, jest.requireActual('react-router-dom')), {}, {
  useNavigate: () => mockedUsedNavigate
}));
const mocks = [];

const comp = /*#__PURE__*/_react.default.createElement(_testing.MockedProvider, {
  mocks: mocks
}, /*#__PURE__*/_react.default.createElement(_ChatList.default, null));

describe('rendring of components', () => {
  it('It should mount', () => {
    const div = document.createElement('div');

    _reactDom.default.render(comp, div);

    _reactDom.default.unmountComponentAtNode(div);
  });
});
describe('data from query', () => {
  it('It should mount with data', async () => {
    const loadusersmock = {
      request: {
        query: _Queries.LOAD_USERS
      },
      result: {
        data: {
          queryHC_Lead: [{
            username: "Sahil Thakur",
            id: "0x2725",
            threads: [{
              id: "0x2724",
              messages: [{
                from: "whatsapp:+918988413260",
                to: "whatsapp:+14155238886",
                timestamp: "1637295513344",
                body: "Sending first message",
                __typename: "Message"
              }, {
                from: "whatsapp:+918988413260",
                to: "whatsapp:+14155238886",
                timestamp: "1637295528041",
                body: "Second message from me",
                __typename: "Message"
              }],
              __typename: "Thread"
            }],
            __typename: "HC_Lead"
          }]
        }
      }
    };

    let el = /*#__PURE__*/_react.default.createElement(_testing.MockedProvider, {
      mocks: [loadusersmock]
    }, /*#__PURE__*/_react.default.createElement(_ChatList.default, null));

    await new Promise(resolve => setTimeout(resolve, 4000)); // wait for response

    const {
      container,
      getByText
    } = (0, _react2.render)(el);
  });
});