"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _icons = require("@ant-design/icons");

var _client = require("@apollo/client");

var _antd = require("antd");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _ChatContext = _interopRequireDefault(require("../../context/chat/ChatContext"));

var _Queries = require("../../GraphQL/Queries");

var _ChatList = _interopRequireDefault(require("../ChatList/ChatList"));

var _SearchList = _interopRequireDefault(require("../SearchList/SearchList"));

var _ChatListShellModule = _interopRequireDefault(require("./ChatListShell.module.scss"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const {
  TabPane
} = _antd.Tabs;
const {
  Option
} = _antd.Select;

const ChatListShell = _ref => {
  var _query$parameter;

  let {
    options,
    query,
    resetChatList,
    isUsername,
    isSearchedMessageSelected,
    setQueryMessagesBody
  } = _ref;
  const {
    fetchUnrepliedCount,
    newMessages,
    modifyCount
  } = (0, _react.useContext)(_ChatContext.default);
  const [chatOptions, setChatOptions] = (0, _react.useState)([]);
  const [selectedOption, setSelectedOption] = (0, _react.useState)("allchats");
  const {
    data
  } = (0, _client.useSubscription)(_Queries.LOAD_USERS);
  const navigate = (0, _reactRouterDom.useNavigate)();
  (0, _react.useEffect)(() => {
    setChatOptions(options);
  }, [options]);
  (0, _react.useEffect)(() => {
    fetchUnrepliedCount();
  }, []);

  const handleChatOptions = value => {
    setSelectedOption(value);
  };

  (0, _react.useEffect)(() => {
    if (newMessages.length > 0) {
      // iterate to check if latest message inside each conversation matches newMessage
      let newMessageExist = false;

      if (newMessages[0].type === "received" && data && data.queryHC_Lead) {
        for (let i = 0; i < data.queryHC_Lead.length; i++) {
          const thread = data.queryHC_Lead[i];

          if (thread.threads.length > 0) {
            var _thread$threads$0$mes;

            let messageId = (_thread$threads$0$mes = thread.threads[0].messages[0]) === null || _thread$threads$0$mes === void 0 ? void 0 : _thread$threads$0$mes.id;

            if (messageId === newMessages[0].id) {
              newMessageExist = true;
              break;
            }
          }
        }
      }

      if (!newMessageExist) {
        modifyCount(newMessages);
      }
    }
  }, [newMessages]);

  const handleStopSearching = () => {
    resetChatList();
    navigate('/chat');
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: isUsername || isSearchedMessageSelected ? "".concat(_ChatListShellModule.default.ChatListShell__hide + " " + _ChatListShellModule.default.ChatListShell) : _ChatListShellModule.default.ChatListShell
  }, (query === null || query === void 0 ? void 0 : (_query$parameter = query.parameter) === null || _query$parameter === void 0 ? void 0 : _query$parameter.length) === 0 ? /*#__PURE__*/_react.default.createElement("div", {
    className: _ChatListShellModule.default.ChatListShell__bar
  }, /*#__PURE__*/_react.default.createElement(_antd.Select, {
    defaultValue: "allchats",
    bordered: false,
    value: selectedOption,
    "data-testid": "ChatListShell-select",
    onChange: handleChatOptions
  }, chatOptions === null || chatOptions === void 0 ? void 0 : chatOptions.map(op => {
    return /*#__PURE__*/_react.default.createElement(Option, {
      key: op.id,
      value: op.value
    }, op.label);
  }))) : /*#__PURE__*/_react.default.createElement("div", {
    className: _ChatListShellModule.default.ChatListShell__search_heading
  }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_icons.ArrowLeftOutlined, {
    onClick: handleStopSearching
  }), /*#__PURE__*/_react.default.createElement("span", {
    "data-testid": "search-heading",
    className: _ChatListShellModule.default.ChatListShell__heading
  }, "Search"))), (query === null || query === void 0 ? void 0 : query.parameter.length) === 0 ? /*#__PURE__*/_react.default.createElement("div", {
    className: _ChatListShellModule.default.ChatListShell__mobilebar,
    "data-testid": "ChatListShell-mobilebar"
  }, /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    defaultActiveKey: "allchats",
    onChange: handleChatOptions,
    centered: true
  }, chatOptions === null || chatOptions === void 0 ? void 0 : chatOptions.map(op => {
    return /*#__PURE__*/_react.default.createElement(TabPane, {
      tab: op.label,
      key: op.value
    });
  }))) : null, (query === null || query === void 0 ? void 0 : query.parameter.length) === 0 ? selectedOption === "allchats" ? /*#__PURE__*/_react.default.createElement(_ChatList.default, {
    data: data
  }) : /*#__PURE__*/_react.default.createElement("div", null) : /*#__PURE__*/_react.default.createElement(_SearchList.default, {
    query: query,
    setQueryMessagesBody: setQueryMessagesBody
  }));
};

var _default = ChatListShell;
exports.default = _default;
ChatListShell.propTypes = {
  query: _propTypes.default.shape({
    parameter: _propTypes.default.string
  }),
  resetChatList: _propTypes.default.func
};
ChatListShell.defaultProps = {
  query: {
    parameter: ""
  },
  resetChatList: () => console.log("This function will reset the ChatListSheel to its default state")
};