"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.array.reverse.js");

var _react = _interopRequireWildcard(require("react"));

var _Message = _interopRequireDefault(require("../Message/Message"));

var _ConversationModule = _interopRequireDefault(require("./Conversation.module.scss"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Conversation = _ref => {
  let {
    user,
    msgObj,
    queryMessages,
    centralMessage,
    query,
    queryMessagesBody
  } = _ref;
  const [chatData, setChatData] = (0, _react.useState)([]);
  const [retain, setRetain] = (0, _react.useState)(false);
  (0, _react.useEffect)(() => {
    if (user) {
      var _user$getHC_Lead, _user$getHC_Lead$thre;

      setChatData(user === null || user === void 0 ? void 0 : (_user$getHC_Lead = user.getHC_Lead) === null || _user$getHC_Lead === void 0 ? void 0 : (_user$getHC_Lead$thre = _user$getHC_Lead.threads[0]) === null || _user$getHC_Lead$thre === void 0 ? void 0 : _user$getHC_Lead$thre.messages);
      setRetain(true);
    }
  }, [user]);
  (0, _react.useEffect)(() => {
    if ((queryMessages === null || queryMessages === void 0 ? void 0 : queryMessages.length) !== 0) {
      setChatData(queryMessages);
      setRetain(false);
    }
  }, [queryMessages]);
  (0, _react.useEffect)(() => {
    if (retain) {
      if (msgObj !== undefined && msgObj !== null) {
        if (Object.keys(msgObj).length > 0) {
          var _chatData;

          const msgExistsInConversation = (chatData === null || chatData === void 0 ? void 0 : (_chatData = chatData[chatData.length - 1]) === null || _chatData === void 0 ? void 0 : _chatData.id) === msgObj.id;
          delete msgObj.thread; // delete msgObj.id

          if (!msgExistsInConversation) {
            let appendNewMsg = [...chatData, msgObj];
            return setChatData(appendNewMsg);
          }
        }
      }
    }
  }, [retain, msgObj]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationModule.default.Conversation
  }, chatData === null || chatData === void 0 ? void 0 : chatData.map((message, index) => {
    var _user$getHC_Lead2;

    return /*#__PURE__*/_react.default.createElement(_Message.default, {
      name: user === null || user === void 0 ? void 0 : (_user$getHC_Lead2 = user.getHC_Lead) === null || _user$getHC_Lead2 === void 0 ? void 0 : _user$getHC_Lead2.username,
      key: index,
      isMyMessage: message.type === "sent",
      message: message,
      query: query,
      centralMessage: centralMessage,
      queryMessagesBody: queryMessagesBody
    });
  }).reverse());
};

var _default = Conversation;
exports.default = _default;