"use strict";

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _ConversationContainer = _interopRequireDefault(require("./ConversationContainer"));

var _testing = require("@apollo/client/testing");

var _Queries = require("../../GraphQL/Queries");

var _react2 = require("@testing-library/react");

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const mocks = [];

const comp = /*#__PURE__*/_react.default.createElement(_testing.MockedProvider, {
  mocks: mocks
}, /*#__PURE__*/_react.default.createElement(_ConversationContainer.default, null));

describe('rendring of components', () => {
  it('It should mount', () => {
    const div = document.createElement('div');

    _reactDom.default.render(comp, div);

    _reactDom.default.unmountComponentAtNode(div);
  });
  it('Input field should be rendered', () => {
    const {
      getByPlaceholderText
    } = (0, _react2.render)(comp);
    expect(getByPlaceholderText('Input placeholder')).toBeInTheDocument();
  });
});
describe('chatitem selection behaviour', () => {
  it('Input should change when message is typed ', () => {
    const {
      queryByTestId,
      getByPlaceholderText,
      getByText
    } = (0, _react2.render)(comp);

    _react2.fireEvent.change(getByPlaceholderText('Input placeholder'), {
      target: {
        value: 'new value'
      }
    });

    expect(getByPlaceholderText('Input placeholder')).toHaveValue('new value');
  });
});