"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.profilePicPlaceholderStyle = exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.promise.js");

var _icons = require("@ant-design/icons");

var _client = require("@apollo/client");

var _antd = require("antd");

var _hcInboxProfile = require("hc-inbox-profile");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _api = require("../../api/api");

var _ChatContext = _interopRequireDefault(require("../../context/chat/ChatContext"));

var _Queries = require("../../GraphQL/Queries");

var _giveHeader = _interopRequireDefault(require("../../_helpers/giveHeader"));

var _ConversationContainer = _interopRequireDefault(require("../ConversationContainer/ConversationContainer"));

var _Filetable = _interopRequireDefault(require("../Filetable/Filetable"));

var _Participants = _interopRequireDefault(require("../Participants/Participants"));

var _Userdetailsdropdown = _interopRequireDefault(require("../Userdetailsdropdown/Userdetailsdropdown"));

var _giveHeaders = _interopRequireDefault(require("../../_helpers/giveHeaders"));

var _ConversationShellModule = _interopRequireDefault(require("./ConversationShell.module.scss"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const {
  TabPane
} = _antd.Tabs;
const tabStyles = {
  paddingTop: "20px"
};
const profilePicPlaceholderStyle = {
  height: "40px",
  width: "40px",
  fontSize: "1em"
};
exports.profilePicPlaceholderStyle = profilePicPlaceholderStyle;
const TIMEOUT = 300;
/***************************************************Object for tabs***************************************************************/

const allTabs = {
  chat: "1",
  files: "2",
  starredMsg: "3"
};

const ConversationShell = _ref => {
  var _data$getHC_Lead, _data$getHC_Lead2, _data$getHC_Lead3, _data$getHC_Lead4, _data$getHC_Lead4$thr, _data$getHC_Lead5, _data$getHC_Lead6;

  let {
    chatApiUrl,
    backendApiUrl,
    query,
    queryMessagesBody,
    handleSetIsUsername
  } = _ref;
  const navigate = (0, _reactRouterDom.useNavigate)();
  const chatContext = (0, _react.useContext)(_ChatContext.default);
  const {
    storeNewMessages
  } = chatContext;
  const {
    username
  } = (0, _reactRouterDom.useParams)();
  const {
    data,
    refetch,
    loading
  } = (0, _client.useQuery)(_Queries.LOAD_MESSAGES, {
    variables: {
      leadId: username
    }
  });
  /**********************************************For setting different tabs**********************************************************************/

  const [tab, setTab] = (0, _react.useState)(allTabs.chat);
  const {
    data: newMessagesData
  } = (0, _client.useSubscription)(_Queries.LOAD_NEWMESSAGES);

  const [queryMessages, setQueryMessage] = _react.default.useState([]);

  const [centralMessage, setCentralMessage] = _react.default.useState(undefined);

  (0, _react.useEffect)(() => {
    handleSetIsUsername(username);
    refetch();
  }, [username]);
  (0, _react.useEffect)(() => {
    if (newMessagesData) {
      storeNewMessages(newMessagesData === null || newMessagesData === void 0 ? void 0 : newMessagesData.queryMessage);
    }
  }, [newMessagesData]);
  (0, _react.useEffect)(() => {
    setQueryMessage([]);

    const fetchQueryMessages = async () => {
      if (queryMessagesBody !== null & (queryMessagesBody === null || queryMessagesBody === void 0 ? void 0 : queryMessagesBody.threadId) !== null) {
        const headers = (0, _giveHeaders.default)();

        if (headers !== null) {
          const {
            data
          } = await (0, _api.getQueryMessages)(backendApiUrl, queryMessagesBody, headers);
          setQueryMessage(data.messages);
          setCentralMessage(data.centralMessage);
        } else {
          navigate('/');
        }
      }
    };

    fetchQueryMessages();
  }, [queryMessagesBody]);

  function callback(key) {
    setTab(key);
    console.log(key);
  }

  const name = (data === null || data === void 0 ? void 0 : (_data$getHC_Lead = data.getHC_Lead) === null || _data$getHC_Lead === void 0 ? void 0 : _data$getHC_Lead.username) || "";
  const [userdetailsvisible, setUserdetailsvisible] = (0, _react.useState)(false);
  let timer = 0;

  function mouseEnter() {
    timer = setTimeout(() => {
      setUserdetailsvisible(true);
    }, TIMEOUT);
  }

  return /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell
  }, !username && queryMessagesBody === null ? /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__bar
  }, /*#__PURE__*/_react.default.createElement("span", {
    "data-testid": "selectcontact",
    className: _ConversationShellModule.default.ConversationShell__bar__selectcontact
  }, "Select a contact")) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__bar
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__bar__imgcontainer,
    onMouseEnter: mouseEnter
  }, /*#__PURE__*/_react.default.createElement(_hcInboxProfile.ProfilePicPlaceholder, {
    name: name,
    id: username,
    height: profilePicPlaceholderStyle.height,
    width: profilePicPlaceholderStyle.width,
    fontSize: profilePicPlaceholderStyle.fontSize
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__bar__imgcontainer__status_circle
  })), /*#__PURE__*/_react.default.createElement("h6", {
    className: _ConversationShellModule.default.ConversationShell__bar__name,
    onMouseEnter: mouseEnter
  }, data !== null && data !== void 0 && (_data$getHC_Lead2 = data.getHC_Lead) !== null && _data$getHC_Lead2 !== void 0 && _data$getHC_Lead2.username ? data === null || data === void 0 ? void 0 : (_data$getHC_Lead3 = data.getHC_Lead) === null || _data$getHC_Lead3 === void 0 ? void 0 : _data$getHC_Lead3.username : queryMessagesBody === null || queryMessagesBody === void 0 ? void 0 : queryMessagesBody.profileName), /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__bar__panels
  }, /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    defaultActiveKey: "1",
    onChange: callback,
    tabBarStyle: tabStyles
  }, /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: "Chat",
    key: "1"
  }), /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: "Files",
    key: "2"
  }), /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: "Starred Messages",
    key: "3"
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__bar__participants
  }, /*#__PURE__*/_react.default.createElement(_Participants.default, {
    username: username,
    loggedUser: "Sahil Thakur",
    data: data === null || data === void 0 ? void 0 : (_data$getHC_Lead4 = data.getHC_Lead) === null || _data$getHC_Lead4 === void 0 ? void 0 : (_data$getHC_Lead4$thr = _data$getHC_Lead4.threads[0]) === null || _data$getHC_Lead4$thr === void 0 ? void 0 : _data$getHC_Lead4$thr.participants
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__mobilebar
  }, /*#__PURE__*/_react.default.createElement(_icons.ArrowLeftOutlined, {
    className: _ConversationShellModule.default.ConversationShell__mobilebar__icon,
    onClick: () => window.history.back()
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__mobilebar__imgcontainer,
    onMouseEnter: mouseEnter
  }, /*#__PURE__*/_react.default.createElement(_hcInboxProfile.ProfilePicPlaceholder, {
    name: name,
    id: username,
    height: profilePicPlaceholderStyle.height,
    width: profilePicPlaceholderStyle.width,
    fontSize: profilePicPlaceholderStyle.fontSize
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__mobilebar__imgcontainer__status_circle
  })), /*#__PURE__*/_react.default.createElement("h6", {
    className: _ConversationShellModule.default.ConversationShell__mobilebar__name,
    onMouseEnter: mouseEnter
  }, data !== null && data !== void 0 && (_data$getHC_Lead5 = data.getHC_Lead) !== null && _data$getHC_Lead5 !== void 0 && _data$getHC_Lead5.username ? data === null || data === void 0 ? void 0 : (_data$getHC_Lead6 = data.getHC_Lead) === null || _data$getHC_Lead6 === void 0 ? void 0 : _data$getHC_Lead6.username : queryMessagesBody === null || queryMessagesBody === void 0 ? void 0 : queryMessagesBody.profileName), /*#__PURE__*/_react.default.createElement(_icons.SearchOutlined, {
    className: _ConversationShellModule.default.ConversationShell__mobilebar__icon
  }), /*#__PURE__*/_react.default.createElement(_icons.MoreOutlined, {
    className: _ConversationShellModule.default.ConversationShell__mobilebar__icon
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: _ConversationShellModule.default.ConversationShell__mobileTabs
  }, /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    defaultActiveKey: "1",
    onChange: callback,
    tabBarStyle: tabStyles,
    className: _ConversationShellModule.default.ConversationShell__mobileTabs__container
  }, /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: "Chat",
    key: "1",
    className: _ConversationShellModule.default.ConversationShell__mobileTabs__container__tabpane
  }), /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: "Files",
    key: "2",
    className: _ConversationShellModule.default.ConversationShell__mobileTabs__container__tabpane
  }), /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: "Starred",
    key: "3",
    className: _ConversationShellModule.default.ConversationShell__mobileTabs__container__tabpane
  })))), loading ? /*#__PURE__*/_react.default.createElement(_antd.Spin, {
    size: "large",
    className: _ConversationShellModule.default.ConversationShell__loading
  }) : tab === allTabs.chat ? /*#__PURE__*/_react.default.createElement(_ConversationContainer.default, {
    newMessagesData: newMessagesData,
    user: data,
    selectedId: username,
    refetch: refetch,
    chatApiUrl: chatApiUrl,
    centralMessage: centralMessage,
    query: query,
    queryMessages: queryMessages,
    queryMessagesBody: queryMessagesBody
  }) : tab == allTabs.files ? /*#__PURE__*/_react.default.createElement(_Filetable.default, null) : null, userdetailsvisible ? /*#__PURE__*/_react.default.createElement(_Userdetailsdropdown.default, {
    close: () => setUserdetailsvisible(false)
  }) : null);
};
/**
 * Need to define propTypes & defaultProps as it is causing test cases failed because 
 * the initial value it is receing is undefined. So to avoid extra code for checking,
 * we provide null value which is the initial value of queryMessagesBody
 */


ConversationShell.propTypes = {
  queryMessagesBody: _propTypes.default.object
};
ConversationShell.defaultProps = {
  queryMessagesBody: null
};
var _default = ConversationShell;
exports.default = _default;