"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.string.split.js");

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FiletableModule = _interopRequireDefault(require("./Filetable.module.scss"));

var _antd = require("antd");

var _image = _interopRequireDefault(require("../../assets/Icon/image.svg"));

var _pdf = _interopRequireDefault(require("../../assets/Icon/pdf.svg"));

var _play = _interopRequireDefault(require("../../assets/Icon/play.svg"));

var _icons = require("@ant-design/icons");

var _reactResponsive = require("react-responsive");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*****************************************************object of icon************************************************************************/
const iconObj = {
  jpg: /*#__PURE__*/_react.default.createElement("img", {
    src: _image.default,
    alt: "image-icon"
  }),
  png: /*#__PURE__*/_react.default.createElement("img", {
    src: _image.default,
    alt: "image-icon"
  }),
  jpeg: /*#__PURE__*/_react.default.createElement("img", {
    src: _image.default,
    alt: "image-icon"
  }),
  pdf: /*#__PURE__*/_react.default.createElement("img", {
    src: _pdf.default,
    alt: "doc-icon"
  }),
  mp4: /*#__PURE__*/_react.default.createElement("img", {
    src: _play.default,
    alt: "videoplay-icon"
  })
};

function getFileType(filename) {
  let extension = filename.split('.').pop();
  return iconObj[extension];
}

const dataReformat = data => {
  const newData = [];

  for (let i = 0; i < (data === null || data === void 0 ? void 0 : data.length); i++) {
    newData.push({
      key: i + 1,
      type: getFileType(data[i].name),
      name: /*#__PURE__*/_react.default.createElement("a", {
        href: data[i].link,
        target: "_blank",
        rel: "noopener noreferrer"
      }, data[i].name),
      sentBy: data[i].sentBy,
      date: data[i].date
    });
  }

  return newData;
};
/******************************************************For share files************************************************************************/


const props = {
  name: 'file',
  action: 'https://www.mocky.io/v2/5cc8019d300000980a055e76',
  headers: {
    authorization: 'authorization-text'
  },

  onChange(info) {
    if (info.file.status !== 'uploading') {
      console.log(info.file, info.fileList);
    }

    if (info.file.status === 'done') {
      _antd.message.success("".concat(info.file.name, " file uploaded successfully"));
    } else if (info.file.status === 'error') {
      _antd.message.error("".concat(info.file.name, " file upload failed."));
    }
  }

};
/******************************************************Function for showing confirm box for delete****************************************************************/

const {
  confirm
} = _antd.Modal;

function showDeleteConfirm(fileCount) {
  confirm({
    title: "Are you sure you want to delete ".concat(fileCount, " file?"),
    icon: /*#__PURE__*/_react.default.createElement(_icons.ExclamationCircleOutlined, null),
    content: 'This action is not reversible',
    okText: 'Delete',
    okType: 'danger primary',
    cancelText: 'Cancel',

    onOk() {
      _antd.message.success('File Deleted!');
    },

    onCancel() {// console.log('Cancel');
    }

  });
}
/*********************************************************Function for handling copy link**********************************************************************/


function handleCopy() {
  _antd.message.success('Link Copied!');
}

_antd.message.config({
  top: 100,
  duration: 5,
  maxCount: 3
});

const Filetable = _ref => {
  let {
    data
  } = _ref;

  /*********************************************for dispalying the option buttons on the top********************************************************************/
  const [selectedRowKeys, setselectedRowKeys] = (0, _react.useState)([]);
  const rowSelection = {
    selectedRowKeys,
    onChange: setselectedRowKeys
  };
  /*************************************************for altering the custom arrow icon of sorting for Name-section******************************************************************************/

  const [orderDirection, setOrderDirection] = (0, _react.useState)(true);
  /*****************************************************for altering the custom arrow icon of sorting for Sent By-section*****************************************************************************/

  const [sentsortDirection, setSentsortDirection] = (0, _react.useState)(true);
  /********************************************************for altering the custom arrow icon of sorting for date-section************************************************************************/

  const [datesortDirection, setDatesortDirection] = (0, _react.useState)(true);
  /***********************************************************For device width screen detection***********************************************************************/

  const isDesktopOrLaptop = (0, _reactResponsive.useMediaQuery)({
    query: '(min-width: 980px)'
  });
  /************************************************column name********************************************************/

  const columns = [{
    title: 'Type',
    dataIndex: 'type',
    width: isDesktopOrLaptop ? '12%' : '14%'
  }, {
    title: ' ',
    render: record => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, record.name, /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement("span", null, 'Sent by ' + record.sentBy)),
    responsive: ['xs']
  }, {
    title: /*#__PURE__*/_react.default.createElement("div", {
      className: _FiletableModule.default.Filetable__mainContainer__table__titleContainer
    }, "Name", /*#__PURE__*/_react.default.createElement("button", {
      onClick: () => setOrderDirection(!orderDirection)
    }, orderDirection ? /*#__PURE__*/_react.default.createElement(_icons.CaretDownOutlined, null) : /*#__PURE__*/_react.default.createElement(_icons.CaretUpOutlined, null))),
    dataIndex: 'name',
    sorter: (a, b) => a.name.props.children.localeCompare(b.name.props.children),
    sortOrder: orderDirection ? 'descend' : 'ascend',
    multiple: 1,
    width: isDesktopOrLaptop ? '50%' : '37%',
    responsive: ['sm']
  }, {
    title: /*#__PURE__*/_react.default.createElement("div", {
      className: _FiletableModule.default.Filetable__mainContainer__table__titleContainer
    }, "Sent By", /*#__PURE__*/_react.default.createElement("button", {
      onClick: () => setSentsortDirection(!sentsortDirection)
    }, sentsortDirection ? /*#__PURE__*/_react.default.createElement(_icons.CaretDownOutlined, null) : /*#__PURE__*/_react.default.createElement(_icons.CaretUpOutlined, null))),
    dataIndex: 'sentBy',
    // sorter: (a, b) =>  {please write function for sorting according to sent by},
    sortOrder: sentsortDirection ? 'descend' : 'ascend',
    multiple: 1,
    width: isDesktopOrLaptop ? '19%' : '24%',
    responsive: ['sm']
  }, {
    title: /*#__PURE__*/_react.default.createElement("div", {
      className: _FiletableModule.default.Filetable__mainContainer__table__titleContainer
    }, "Date", /*#__PURE__*/_react.default.createElement("button", {
      onClick: () => setDatesortDirection(!datesortDirection)
    }, datesortDirection ? /*#__PURE__*/_react.default.createElement(_icons.CaretDownOutlined, null) : /*#__PURE__*/_react.default.createElement(_icons.CaretUpOutlined, null))),
    dataIndex: 'date',
    //sorter: (a, b) =>{please write function for sorting according to date},
    sortOrder: datesortDirection ? 'descend' : 'ascend',
    multiple: 2,
    width: isDesktopOrLaptop ? '19%' : '25%'
  }];
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _FiletableModule.default.Filetable
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: _FiletableModule.default.Filetable__mainContainer
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: _FiletableModule.default.Filetable__mainContainer__btnContainer
  }, selectedRowKeys.length === 0 ? /*#__PURE__*/_react.default.createElement(_antd.Upload, props, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.UploadOutlined, null),
    className: _FiletableModule.default.Filetable__mainContainer__btnContainer__upload
  }, "Share Files")) : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.DeleteOutlined, null),
    className: _FiletableModule.default.Filetable__mainContainer__btnContainer__actionBtn,
    onClick: () => showDeleteConfirm(selectedRowKeys.length)
  }, "Delete"), selectedRowKeys.length === 1 && /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.LinkOutlined, null),
    className: _FiletableModule.default.Filetable__mainContainer__btnContainer__actionBtn,
    onClick: handleCopy
  }, "Copy"), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.DownloadOutlined, null),
    className: _FiletableModule.default.Filetable__mainContainer__btnContainer__actionBtn,
    onClick: ''
  }, "Download"))), /*#__PURE__*/_react.default.createElement(_antd.Table, {
    rowSelection: rowSelection,
    dataSource: dataReformat(data),
    columns: columns,
    scroll: {
      y: 500
    },
    pagination: {
      pageSize: data.length,
      position: ['none', 'none']
    },
    className: _FiletableModule.default.Filetable__mainContainer__table
  })));
};

Filetable.propTypes = {
  data: _propTypes.default.arrayOf(_propTypes.default.shape({
    name: _propTypes.default.string,
    link: _propTypes.default.string,
    sentBy: _propTypes.default.string,
    date: _propTypes.default.string
  }))
};
Filetable.defaultProps = {
  data: [{
    name: 'Picture.png',
    link: 'https://res.cloudinary.com/stealthman22/image/upload/v1586308023/new-portfolio/hero/two-cargo-ships-sailing-near-city-2144905.jpg',
    sentBy: 'Jack Daniels',
    date: '19/01/22'
  }, {
    name: 'Document.pdf',
    link: 'http://www.africau.edu/images/default/sample.pdf',
    sentBy: 'Alan Walker',
    date: '17/06/21'
  }, {
    name: 'Video.mp4',
    link: 'http://techslides.com/demos/sample-videos/small.mp4',
    sentBy: 'Ricky Martin',
    date: '15/04/21'
  }]
};
var _default = Filetable;
exports.default = _default;