"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.parse-int.js");

var _react = _interopRequireDefault(require("react"));

var _reactHighlightWords = _interopRequireDefault(require("react-highlight-words"));

require("./Message.scss");

var _classnames = _interopRequireDefault(require("classnames"));

var _getHoursFromTimestamp = require("../../_helpers/getHoursFromTimestamp");

var _reactRouterDom = require("react-router-dom");

var _hcInboxProfile = require("hc-inbox-profile");

var _ConversationShell = require("../ConversationShell/ConversationShell");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const Message = _ref => {
  var _queryMessagesBody$us, _queryMessagesBody$us2, _queryMessagesBody$us3, _queryMessagesBody$us4;

  let {
    name,
    query,
    isMyMessage,
    message,
    centralMessage,
    queryMessagesBody
  } = _ref;
  const {
    username
  } = (0, _reactRouterDom.useParams)();
  const messageClass = (0, _classnames.default)("message-row", {
    "you-message": isMyMessage,
    "other-message": !isMyMessage
  });
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "Message"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: messageClass
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "message-content"
  }, isMyMessage ? null : /*#__PURE__*/_react.default.createElement("div", {
    className: "img-container"
  }, /*#__PURE__*/_react.default.createElement(_hcInboxProfile.ProfilePicPlaceholder, {
    name: queryMessagesBody ? (_queryMessagesBody$us = queryMessagesBody.user) === null || _queryMessagesBody$us === void 0 ? void 0 : _queryMessagesBody$us.username : name,
    id: queryMessagesBody ? (_queryMessagesBody$us2 = queryMessagesBody.user) === null || _queryMessagesBody$us2 === void 0 ? void 0 : (_queryMessagesBody$us3 = _queryMessagesBody$us2.thread) === null || _queryMessagesBody$us3 === void 0 ? void 0 : (_queryMessagesBody$us4 = _queryMessagesBody$us3.sender) === null || _queryMessagesBody$us4 === void 0 ? void 0 : _queryMessagesBody$us4.id : username,
    height: _ConversationShell.profilePicPlaceholderStyle.height,
    width: _ConversationShell.profilePicPlaceholderStyle.width,
    fontSize: _ConversationShell.profilePicPlaceholderStyle.fontSize
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "img-container-status-circle"
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "message-container ".concat(queryMessagesBody !== null ? (message === null || message === void 0 ? void 0 : message.id) === centralMessage ? "selected-message" : "" : "")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "message-title"
  }, !isMyMessage && /*#__PURE__*/_react.default.createElement("span", null, message === null || message === void 0 ? void 0 : message.from), /*#__PURE__*/_react.default.createElement("span", null, (0, _getHoursFromTimestamp.getHoursFromTimestamp)(parseInt(message === null || message === void 0 ? void 0 : message.timestamp)))), /*#__PURE__*/_react.default.createElement("div", {
    className: "message-body"
  }, queryMessagesBody !== null ? (message === null || message === void 0 ? void 0 : message.id) === centralMessage ? /*#__PURE__*/_react.default.createElement(_reactHighlightWords.default, {
    highlightClassName: "highlighted-search-text",
    searchWords: [query === null || query === void 0 ? void 0 : query.parameter],
    textToHighlight: message !== null && message !== void 0 && message.body ? message.body : ""
  }) : message === null || message === void 0 ? void 0 : message.body : message === null || message === void 0 ? void 0 : message.body)))));
};

var _default = Message;
exports.default = _default;