"use strict";

require("core-js/modules/es.promise.js");

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _Message = _interopRequireDefault(require("./Message"));

var _testing = require("@apollo/client/testing");

var _Queries = require("../../GraphQL/Queries");

var _react2 = require("@testing-library/react");

var _reactTestRenderer = _interopRequireDefault(require("react-test-renderer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const mocks = [];

const comp = /*#__PURE__*/_react.default.createElement(_testing.MockedProvider, {
  mocks: mocks
}, /*#__PURE__*/_react.default.createElement(_Message.default, null));

describe('rendring of components', () => {
  it('It should mount', () => {
    const div = document.createElement('div');

    _reactDom.default.render(comp, div);

    _reactDom.default.unmountComponentAtNode(div);
  });
});
describe('data from query', () => {
  it('message is rendered', async () => {
    let samplemsg = {
      from: "whatsapp:+918988413260",
      to: "whatsapp:+14155238886",
      timestamp: "1637295513344",
      body: "Sending first message",
      __typename: "Message"
    };

    let el = /*#__PURE__*/_react.default.createElement(_testing.MockedProvider, {
      mocks: []
    }, /*#__PURE__*/_react.default.createElement(_Message.default, {
      message: samplemsg
    }));

    await new Promise(resolve => setTimeout(resolve, 1000)); // wait for response

    const {
      container,
      getByText
    } = (0, _react2.render)(el);
    await (0, _react2.waitFor)(() => expect(getByText("Sending first message")).toBeInTheDocument());
  });
  it('if message is ours then color is blue', async () => {
    let samplemsg = {
      from: "whatsapp:+918988413260",
      to: "whatsapp:+14155238886",
      timestamp: "1637295513344",
      body: "Sending first message",
      __typename: "Message"
    };

    let el = /*#__PURE__*/_react.default.createElement(_testing.MockedProvider, {
      mocks: []
    }, /*#__PURE__*/_react.default.createElement(_Message.default, {
      message: samplemsg,
      isMyMessage: true
    }));

    await new Promise(resolve => setTimeout(resolve, 1000)); // wait for response

    const {
      container,
      getByText
    } = (0, _react2.render)(el);
    expect(container.firstChild.firstChild).toHaveClass("you-message");
  });
  it('if message is theirs then color is not blue', async () => {
    let samplemsg = {
      from: "whatsapp:+918988413260",
      to: "whatsapp:+14155238886",
      timestamp: "1637295513344",
      body: "Sending first message",
      __typename: "Message"
    };

    let el = /*#__PURE__*/_react.default.createElement(_testing.MockedProvider, {
      mocks: []
    }, /*#__PURE__*/_react.default.createElement(_Message.default, {
      message: samplemsg,
      isMyMessage: false
    }));

    await new Promise(resolve => setTimeout(resolve, 1000)); // wait for response

    const {
      container,
      getByText
    } = (0, _react2.render)(el);
    expect(container.firstChild.firstChild).toHaveClass("other-message");
  });
});