"use strict";

require("core-js/modules/es.promise.js");

var _testing = require("@apollo/client/testing");

var _react = require("@testing-library/react");

var _react2 = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _ChatContext = _interopRequireDefault(require("../../context/chat/ChatContext"));

var _Participants = _interopRequireDefault(require("./Participants"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const mockedUsedNavigate = jest.fn();
jest.mock('react-router-dom', () => _objectSpread(_objectSpread({}, jest.requireActual('react-router-dom')), {}, {
  useNavigate: () => mockedUsedNavigate
}));
const mocks = [];

const comp = /*#__PURE__*/_react2.default.createElement(_ChatContext.default.Provider, {
  value: {}
}, /*#__PURE__*/_react2.default.createElement(_testing.MockedProvider, {
  mocks: mocks
}, /*#__PURE__*/_react2.default.createElement(_Participants.default, {
  username: "0x2725"
})), "    ");

it('It should mount', () => {
  const div = document.createElement('div');

  _reactDom.default.render(comp, div);

  _reactDom.default.unmountComponentAtNode(div);
});
beforeAll(() => {
  Object.defineProperty(window, 'matchMedia', {
    value: () => {
      return {
        matches: false,
        addListener: () => {},
        removeListener: () => {}
      };
    }
  });
});
describe('data from query', () => {
  it('It should mount with data', async () => {
    let el = /*#__PURE__*/_react2.default.createElement(_ChatContext.default.Provider, {
      value: {}
    }, /*#__PURE__*/_react2.default.createElement(_testing.MockedProvider, {
      mocks: []
    }, /*#__PURE__*/_react2.default.createElement(_Participants.default, {
      username: "0x2725",
      loggedUser: "Sahil Thakur",
      data: [{
        username: "Sahil Thakur"
      }, {
        username: "TestStaff"
      }]
    })), "   ");

    const {
      container,
      getAllByText
    } = (0, _react.render)(el);
    await new Promise(resolve => setTimeout(resolve, 2000)); // wait for response

    expect(container.getElementsByClassName('ant-avatar ant-avatar-circle').length).toBe(2);
  });
});