"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.regexp.to-string.js");

var _icons = require("@ant-design/icons");

var _client = require("@apollo/client");

var _antd = require("antd");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _Queries = require("../../GraphQL/Queries");

var _giveHeaders = _interopRequireDefault(require("../../_helpers/giveHeaders"));

var _Contactsearch = _interopRequireDefault(require("../Contactsearch/Contactsearch"));

var _Filesearch = _interopRequireDefault(require("../Filesearch/Filesearch"));

var _Filterdropdown = _interopRequireDefault(require("../Filterdropdown/Filterdropdown"));

var _Filteroutput = _interopRequireDefault(require("../Filteroutput/Filteroutput"));

var _MessageItem = _interopRequireDefault(require("../MessageItem/MessageItem"));

var _Sortdropdown = _interopRequireDefault(require("../Sortdropdown/Sortdropdown"));

var _Sortoutput = _interopRequireDefault(require("../Sortoutput/Sortoutput"));

var _SearchListModule = _interopRequireDefault(require("./SearchList.module.scss"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const allTabs = {
  messages: "1",
  contacts: "2",
  files: "3"
};
/**
 * Currently this branch didn't contain the contacts & file searching
 * functionality. So I have hard-corder some code for showing "No matches"
 * message in case of contacts & files.
 */

const SearchList = _ref => {
  let {
    query
  } = _ref;
  const [frommenu, _setFrommenu] = (0, _react.useState)(false);
  const [datemenu, _setDatemenu] = (0, _react.useState)(false);
  /*************************For checkbox selection******************************************/

  const [checkbox, setCheckbox] = (0, _react.useState)([]);

  function handleCheckbox(checkedValues) {
    setCheckbox(checkedValues);
  }
  /*********************************state for checkedboxes******************************************************/


  const [checkedbox, _setCheckedbox] = (0, _react.useState)([]);
  /***********************************For obtaining "from" values******************************************************/

  const [fromname, setFromname] = (0, _react.useState)([]);

  function handleFromname(selectedfromname) {
    setFromname(selectedfromname);
  }
  /***************************************************For obtaining "Date range" values******************************************************************/


  const [daterange, setDaterange] = (0, _react.useState)("");

  function handleDaterange(selecteddaterange) {
    setDaterange(selecteddaterange);
  }
  /*******************************************************For filter toggle ***************************************************************************/


  const [filtertogggle, _setFiltertoggle] = (0, _react.useState)(false);
  /****************************************************display applied filter*************************************************************************/

  const [displayappliedfilter, _setDisplayappliedfilter] = (0, _react.useState)(false);
  /*******************************************************State for Sorting*********************************************************************/

  const [sortoption, setSortoption] = (0, _react.useState)({
    alphabeticalSort: "",
    timeSort: ""
  });
  /***********************************************************display applied sorting*******************************************************************/

  const [displayappliedsorting, setDisplayappliedsorting] = (0, _react.useState)(false);
  const navigate = (0, _reactRouterDom.useNavigate)();
  const {
    data
  } = (0, _client.useQuery)(_Queries.LOAD_SEARCH_LIST, {
    variables: {
      filter: {
        body: {
          anyofterms: query.parameter
        }
      }
    }
  });
  const [queryMessages, setQueryMessages] = (0, _react.useState)([]);
  const [chosen, setChosen] = (0, _react.useState)(null);
  const {
    TabPane
  } = _antd.Tabs;
  const tabStyles = {
    padding: "20px 0px 0px 20px"
  };
  const [tab, setTab] = (0, _react.useState)(allTabs.messages);
  (0, _react.useEffect)(() => {
    if (data) {
      setQueryMessages(data.queryMessage);
    }
  }, [data]);

  const handleMessageSelect = user => {
    const headers = (0, _giveHeaders.default)();

    if (headers !== null) {
      if (user.id === chosen) return;
      const threadId = user.thread !== null ? user.thread.id : user.thread;

      if (threadId !== null) {
        setChosen(user.id);
        navigate("/chat?profileName=".concat(user.username.toString(), "&&threadId=").concat(threadId, "&&messageId=").concat(user.id));
      } else {
        setChosen('');
      }
    } else {
      setChosen('');
      navigate('/login');
    }
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: _SearchListModule.default.SearchList
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: _SearchListModule.default.SearchList__bar__panels
  }, /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    defaultActiveKey: "1",
    tabBarStyle: tabStyles,
    onChange: key => setTab(key)
  }, /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: "Messages",
    key: allTabs.messages
  }), /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: "Contacts",
    key: allTabs.contacts
  }), /*#__PURE__*/_react.default.createElement(TabPane, {
    tab: "Files",
    key: allTabs.files
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: _SearchListModule.default.SearchList__bar__settings
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: _SearchListModule.default.SearchList__bar__settings__options
  }, /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
    overlay: /*#__PURE__*/_react.default.createElement(_Filterdropdown.default, {
      frommenu: frommenu,
      setFrommenu: status => {
        _setFrommenu(status);
      },
      datemenu: datemenu,
      setDatemenu: status => {
        _setDatemenu(status);
      },
      handleCheckbox: handleCheckbox,
      handleFromname: handleFromname,
      handleDaterange: handleDaterange,
      setFiltertoggle: () => _setFiltertoggle(false),
      setDisplayappliedfilter: status => _setDisplayappliedfilter(status),
      checkedbox: checkedbox,
      setCheckedbox: status => _setCheckedbox(status),
      fromname: fromname,
      daterange: daterange
    }),
    trigger: ['click'],
    onClick: () => _setFiltertoggle(true),
    visible: filtertogggle
  }, /*#__PURE__*/_react.default.createElement("a", {
    className: "ant-dropdown-link",
    onClick: e => e.preventDefault()
  }, "Filter ", /*#__PURE__*/_react.default.createElement(_icons.DownOutlined, null)))), /*#__PURE__*/_react.default.createElement("span", {
    className: _SearchListModule.default.SearchList__bar__settings__options
  }, /*#__PURE__*/_react.default.createElement(_antd.Dropdown, {
    overlay: /*#__PURE__*/_react.default.createElement(_Sortdropdown.default, {
      sortoption: sortoption,
      setSortoption: setSortoption,
      setDisplayappliedsorting: setDisplayappliedsorting
    }),
    trigger: ['click']
  }, /*#__PURE__*/_react.default.createElement("a", {
    className: "ant-dropdown-link",
    onClick: e => e.preventDefault()
  }, "Sort ", /*#__PURE__*/_react.default.createElement(_icons.DownOutlined, null))))), displayappliedfilter && /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_Filteroutput.default, {
    checkbox: checkbox,
    fromname: fromname,
    daterange: daterange,
    setDisplayappliedfilter: () => _setDisplayappliedfilter(false)
  })), displayappliedsorting && /*#__PURE__*/_react.default.createElement(_Sortoutput.default, {
    sortoption: sortoption,
    hideappliedsorting: () => setDisplayappliedsorting(false)
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: _SearchListModule.default.SearchList__query_messages_container
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: _SearchListModule.default.SearchList__query_messages_container__inner_area
  }, tab === allTabs.messages ? queryMessages.length ? queryMessages.map((user, index) => {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: index,
      onClick: () => handleMessageSelect(user)
    }, /*#__PURE__*/_react.default.createElement(_MessageItem.default, {
      "data-testid": "ChatItem",
      key: user.id,
      user: user,
      query: query,
      active: user.id === chosen,
      handleActiveMessage: () => setChosen(user.id)
    }));
  }) : /*#__PURE__*/_react.default.createElement("div", {
    className: _SearchListModule.default.SearchList__not_found_msg
  }, "No matches") : tab === allTabs.contacts ? false ? queryMessages.map((user, index) => {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: index,
      onClick: ""
    }, /*#__PURE__*/_react.default.createElement(_Contactsearch.default, {
      "data-testid": "ChatItem",
      key: user.id,
      user: user,
      query: query,
      active: user.id === chosen
    }));
  }) : /*#__PURE__*/_react.default.createElement("div", {
    className: _SearchListModule.default.SearchList__not_found_msg
  }, "No matches") : false ? queryMessages.map((user, index) => {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: index,
      onClick: ""
    }, /*#__PURE__*/_react.default.createElement(_Filesearch.default, {
      "data-testid": "ChatItem",
      key: user.id,
      user: user,
      query: query,
      active: user.id === chosen
    }));
  }) : /*#__PURE__*/_react.default.createElement("div", {
    className: _SearchListModule.default.SearchList__not_found_msg
  }, "No matches"))));
};

SearchList.propTypes = {
  query: _propTypes.default.shape({
    parameter: _propTypes.default.string
  })
};
SearchList.defaultProps = {
  query: {
    parameter: ''
  }
};
var _default = SearchList;
exports.default = _default;