"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

var _reactRouterDom = require("react-router-dom");

var _api = require("../../api/api");

var _ChatContext = _interopRequireDefault(require("./ChatContext"));

var _ChatReducer = _interopRequireDefault(require("./ChatReducer"));

var _Types = require("./types/Types");

var _giveHeaders = _interopRequireDefault(require("../../_helpers/giveHeaders"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ChatState = props => {
  const navigate = (0, _reactRouterDom.useNavigate)();
  const initialState = {
    unrepliedCount: {},
    newMessages: []
  };
  const [state, dispatch] = (0, _react.useReducer)(_ChatReducer.default, initialState);

  const fetchUnrepliedCount = () => {
    const headers = (0, _giveHeaders.default)();

    if (headers !== null) {
      (0, _api.getUnrepliedCount)(props.backendApiUrl, headers).then(res => {
        dispatch({
          type: _Types.SET_UNREPLIEDCOUNT,
          payload: res === null || res === void 0 ? void 0 : res.data
        });
      }).catch(e => console.log(e));
    } else {
      navigate('/login');
    }
  };

  const storeNewMessages = data => {
    dispatch({
      type: _Types.SET_NEWMESSAGES,
      payload: data
    });
  };

  const modifyCount = data => {
    data.forEach(element => {
      var _element$thread;

      dispatch({
        type: _Types.MODIFY_UNREPLIEDCOUNT,
        payload: {
          type: element === null || element === void 0 ? void 0 : element.type,
          threadId: element === null || element === void 0 ? void 0 : (_element$thread = element.thread) === null || _element$thread === void 0 ? void 0 : _element$thread.id
        }
      });
    });
  };

  return /*#__PURE__*/_react.default.createElement(_ChatContext.default.Provider, {
    value: {
      unrepliedCount: state.unrepliedCount,
      newMessages: state.newMessages,
      fetchUnrepliedCount,
      modifyCount,
      storeNewMessages
    }
  }, props.children);
};

var _default = ChatState;
exports.default = _default;